/**
 *******************************************************************************
 * @file    main.c
 *
 * @brief   Main program body.
 *
 * @author  DPM
 *
 * @version V1.0.0
 *
 * @date    2024-5-6
 *
 *******************************************************************************/

/*
    Copyright (c) 2024, DP Microelectronics Inc.

    Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

    1. Redistributions of source code must retain the above copyright notice, this
       list of conditions and the following disclaimer.
    2. Redistributions in binary form must reproduce the above copyright notice,
       this list of conditions and the following disclaimer in the documentation
       and/or other materials provided with the distribution.
    3. Neither the name of the copyright holder nor the names of its contributors
       may be used to endorse or promote products derived from this software without
       specific prior written permission.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
OF SUCH DAMAGE.
*/

/* Files include */
#include "main.h"
#include "dpm32m0xx.h"
#include "dpm32m0xx_eval.h"
#include "systick.h"
#include <stdio.h>

/**
  * @addtogroup DPM32M08X_LibSamples
  * @{
  */

/**
  * @addtogroup ACMP
  * @{
  */

/**
  * @addtogroup ACMP_Compare
  * @{
  */

/* Private typedef --------------------------------------------------------------*/

/* Private define ---------------------------------------------------------------*/

/* Private macro ----------------------------------------------------------------*/

/* Private variables ------------------------------------------------------------*/

/* Private functions ------------------------------------------------------------*/

/**
  * @brief  The program entry function.
  * @retval int
  */
int main(void)
{
  /* Configure the system clock */
  SystemClockInit();

  /* Configure the system tick */
  SystickInit();

  /* LED Init */
  EVAL_LedInit(LED1);
  EVAL_LedInit(LED2);

  /********************* Operation ACMP *********************/
  /* Enable clock */
  RCC_Unlock();
  RCC_APBPeriphClockCmd(RCC_APB_PERIPH_ACMP, ENABLE);
  RCC_AHBPeriphClockCmd(RCC_AHB_PERIPH_GPIO, ENABLE);
  RCC_Lock();

  /* Configure ACMP Positive GPIO */
  GPIO_InitTypeStruct GPIO_InitStruct;
  GPIO_InitStruct.GPIO_Mode = GPIO_MODE_ANALOG;
  GPIO_InitStruct.GPIO_PuPd = GPIO_PUPD_NOPULL;
  GPIO_InitStruct.GPIO_Pin = GPIO_PIN_12 | GPIO_PIN_13;
  GPIO_Init(GPIOD, &GPIO_InitStruct);
  GPIO_AnaAFConfig(GPIOD, GPIO_PIN_12 | GPIO_PIN_13, GPIO_ANA_AF_1);

  /* Configure ACMP0 */
  ACMP_InitTypeStruct ACMP_InitStruct;
  ACMP_StructInit(&ACMP_InitStruct);
  ACMP_InitStruct.ACMP_Polarity = ACMP_POL_NORMAL;
  ACMP_InitStruct.ACMP_PInput = ACMP_IN_P_SEL_ACMP_IN4;
  ACMP_InitStruct.ACMP_NInput = ACMP_IN_N_SEL_ACMP_IN5;
  ACMP_InitStruct.ACMP_Filter.FilterSample = ACMP_FILTER_SAMPLE_DIV16;
  ACMP_InitStruct.ACMP_Filter.FilterLen = ACMP_FILTER_LEN16;
  ACMP_InitStruct.ACMP_Filter.FilterCmd = ENABLE;
  ACMP_InitStruct.ACMP_HYSCmd = DISABLE;
  ACMP_Init(ACMP_CH0, &ACMP_InitStruct);
  /* Enable ACMP0 */
  ACMP_Cmd(ACMP_CH0, ENABLE);

  /* Wait for Ready Status */
  while(ACMP_GetReadyStatus(ACMP_CH0) != SET);

  uint32_t ledTime = 0;

  /* Infinite loop */
  while(1)
  {
    /* Runing led toggle */
    if(ledTime < GetTick())
    {
      ledTime = GetTick() + 1000;
      EVAL_LedToggle(LED1);
    }

    if(ACMP_GetCompareResult(ACMP_CH0) == SET)
    {
      EVAL_LedOn(LED2);
    }
    else
    {
      EVAL_LedOff(LED2);
    }
  }
}



/**
  * @}
  */

/**
  * @}
  */

/**
  * @}
  */

/************************ (C) COPYRIGHT DP *****END OF FILE ***************************/
